

--All content of this file come from jojos38, do not reupload anything without my permission !


local M = {}


--======================================================================VALUES========================================================================
local gravelext = 		sounds.createSFXSource('art/sound/gravelext.ogg', 		'AudioDefaultLoop3D', 	"gravelext", 		v.data.refNodes[0].ref)
local gravelext2 = 		sounds.createSFXSource('art/sound/gravelext2.ogg', 		'AudioDefaultLoop3D', 	"gravelext2", 		v.data.refNodes[0].ref)
local gravelInt = 	 	sounds.createSFXSource('art/sound/gravelint.ogg', 		'AudioDefaultLoop3D', 	"gravelint", 		v.data.refNodes[0].ref)
local gravelSkid =	 	sounds.createSFXSource('art/sound/skid_gravel2.ogg', 	'AudioDefaultLoop3D', 	"gravelskid", 		v.data.refNodes[0].ref)
local waterSound =  	sounds.createSFXSource('art/sound/water.ogg', 			'AudioDefaultLoop3D', 	"WaterSound",		v.data.refNodes[0].ref)		
local waterSplash = 	sounds.createSFXSource('art/sound/watersplash.ogg', 	'AudioDefault3D', 		"Watersplash", 		v.data.refNodes[0].ref)
local woosh = 			sounds.createSFXSource('art/sound/woosh.ogg', 		    'AudioDefault3D',       "woosh",			v.data.refNodes[0].ref)
local settingsUser =    readJsonFile("/mods/sirenmod/config/settings.json")

local flatTire1 = 		sounds.createSFXSource('art/sound/flat/flat1.ogg', 	'AudioDefault3D',   		"flatTire1",     	v.data.refNodes[0].ref)
local flatTire2 = 		sounds.createSFXSource('art/sound/flat/flat2.ogg', 	'AudioDefault3D',   		"flatTire2",     	v.data.refNodes[0].ref)

local cameraMode
local sounds = require("sounds")
local delay = 0
local delaySkid = 0
local delayUnderWater = 0
local stillUnderWater = 0
local carName
local delayTire = 1
local iTable = {} -- Contain all tire timers
local deflateTable = {}
local iTableSave
local iTableBoolean = false
local fadeSoundWater = 0
local fadeSoundDirt = 0
local fadeSoundDirtEnter = 0
--======================================================================VALUES========================================================================







--========================================================== FLAT TIRE SOUND SOUND===========================================================
local tirePulse = false
local tireTimerThreshold = 0.4
local tireTimer = 0
local tireSwitch = 0

local function generateTirePulse(dt, wheelNode)
	tireTimer = tireTimer + dt -- Some code took from the main game
	if tireTimer > tireTimerThreshold then
		tirePulse = not tirePulse
		tireTimer = 0	

		if electrics.values.wheelspeed > 0.5 then	

			tireVolume = electrics.values.wheelspeed/20 
			tirePitch = electrics.values.wheelspeed/20 
			
			if tirePitch < 0.8 then tirePitch = 0.8 elseif tirePitch > 1.2 then tirePitch = 1.2 end
			if tireVolume < tonumber(settingsUser.TireDeflated_MIN_Volume) then tireVolume = tonumber(settingsUser.TireDeflated_MIN_Volume)
			elseif tireVolume > tonumber(settingsUser.TireDeflated_MAX_Volume) then tireVolume = tonumber(settingsUser.TireDeflated_MAX_Volume) end
		
			if tireSwitch == 1 then
				--sounds.playSoundOnceAtNode("flatTire1", wheelNode, tireVolume)	
				obj:playSFXOnce("flatTire1", wheelNode, tireVolume, tirePitch)				
				tireSwitch = 0		
			else
				--sounds.playSoundOnceAtNode("flatTire2", wheelNode, tireVolume)
				obj:playSFXOnce("flatTire2", wheelNode, tireVolume, tirePitch)
				tireSwitch = 1		
			end	

			
		end		
	end
end
--========================================================== FLAT TIRE SOUND SOUND===========================================================







local function onVehicleSwitched()	
		if settingsUser.VehicleSwitchSound == "true" and settingsUser.VehicleSwitchSound ~= nil then
			sounds.playSoundOnceAtNode("woosh", v.data.refNodes[0].ref,  tonumber(settingsUser.VehicleSwitchSoundVolume))	
		end
		obj:queueGameEngineLua("core_camera.switchCamera(0, 1) 	core_camera.switchCamera(0, -1)")
end





--=========================================INITILIZATION===========================================
local function onInit()
	delayTire = 0
	drivingSounds.isTireDeflated = false
	iTable = {}
	deflateTable = {}
	obj:setVolumePitch(gravelInt, 0, 1)
	obj:setVolumePitch(gravelSkid, 0, 1)
	obj:setVolumePitch(gravelext, 0, 1)
	obj:setVolumePitch(gravelext2, 0, 1)
end
--=========================================INITILIZATION===========================================

local function onUpdate(dt)

	obj:queueGameEngineLua("be:getPlayerVehicle(0):queueLuaCommand('if drivingSounds ~= nil then drivingSounds.switchActual = (\"'..be:getPlayerVehicleID(0)..'\") end ')")
	if drivingSounds.switch == nil then drivingSounds.switch = drivingSounds.switchActual end
	if drivingSounds.switchActual ~= drivingSounds.switch then
		drivingSounds.cameraMode = "orbit"
	end

	if 2-electrics.values.wheelspeed/10 > 0.15 then
		tireTimerThreshold = 2-electrics.values.wheelspeed/10
	end
	
--============================================================================================SOME CODE FROM DEV============================================================================================		
	for wi,wd in pairs(wheels.wheels) do	
		local w = wd.obj
		local underWater = obj:inWater(wd.node1) and 1 or 0
		local velocity = vec3(obj:getVelocity()):length()
		local wheelspeed = math.abs(w.angularVelocity * wd.radius)			
		if iTable[wi] == nil then 
			iTable[wi] = 1
		end		
		local skidVol = 0
		local skidPitch = 0
		local rollVol = 0
		local rollPitch = 0

		--sound tuning variables
		local slip = wd.lastSlip
		local minSlip = 3           --the amount of wheel slip where cross fade, skid vol and pitching starts
		local maxSlip = 10          --the amount of wheel slip where cross fade ends, skid vol reaches max
		local skidPitchMaxSlip = 13 --the amount of wheel slip where skid pitch reaches max
		local skidStartPitch = 0.7  --starting pitch of the skid sound (at minSlip condition)
		local skidEndPitch = 1      --ending pitch of the skid sound (at pitchMaxSlip condition)
		local skidVolCurveCoef = 6  --changes the curve of skid volume. Higher number creates a faster onset but doesnt change the max/min volume or pitch.
		local rollCurveCoef = 0.1   --changes the curve of rolling sound and pitch. Higher number creates a faster onset but doesnt change the max/min volume or pitch.
		local rollStartPitch = 0.7  --starting pitch of the roll sound (at 0 wheelspeed)
		local rollEndPitch = 1.2    --ending pitch (at infinite wheelspeed)

		local skidPitchSlope = (skidEndPitch - skidStartPitch) / (skidPitchMaxSlip - minSlip)


		minSlip = math.min(wheelspeed, minSlip)

		-- crossfade smoothly between skid and rolling
		local slipSm = wd.slipSkidFadeSmoother:get(math.min(slip, maxSlip), dt)
		local skidCrossfade =   math.max(0, math.min((slipSm - minSlip) / maxSlip, 1))
		local rollCrossfade =   1 - skidCrossfade

		-- rolling sound
		local rollSpeed = wheelspeed * rollCurveCoef
		rollVol = rollCrossfade * math.min(rollSpeed / (1 + rollSpeed), 1) * 0.134
		rollPitch = rollVol * (rollEndPitch - rollStartPitch) + rollStartPitch

		-- scrubbing/skidding sound
		local slipSmSkidVol = wd.slipSkidVolSmoother:get(math.min(slip, maxSlip), dt)
		skidVol = math.max(slipSmSkidVol - minSlip, 0) / (maxSlip - minSlip) * 0.134

		local slipSmSkidPitch = wd.slipSkidPitchSmoother:get(math.min(slip, skidPitchMaxSlip), dt)
		skidPitch = skidStartPitch + skidPitchSlope * math.min(slipSmSkidPitch, skidPitchMaxSlip - minSlip)
		--apply scaling curve to volume for faster onset of sound
		skidVol = skidVolCurveCoef * skidVol / ((skidVolCurveCoef - 1) * skidVol + 1)			
--============================================================================================SOME CODE FROM DEV============================================================================================				
	




	

--==========================================================SKID AND DRIVING SOUND===========================================================					
		if wd.contactMaterialID1 == 18 or wd.contactMaterialID1 == 15 or wd.contactMaterialID1 == 20 then -- If driving on dirt
		
			delay = 0
				
			if settingsUser.DrivingDirtSound == "true" and settingsUser.DrivingDirtSound ~= nil then -- If user enabled Dirt Sound
				
				obj:setVolumePitch(gravelSkid, skidVol * 3, skidPitch) -- Gravel skid sound
				delaySkid = skidVol
				
				if drivingSounds.cameraMode == "dash" then
					obj:setVolumePitch(gravelInt, rollVol * 40, rollPitch)
					obj:setVolumePitch(gravelext, 0, 1)
					obj:setVolumePitch(gravelext2, 0, 1)
					fadeSoundDirt = rollVol * 40
				else
					
					if fadeSoundDirt <= 0 then 
						if fadeSoundDirtEnter < rollVol * 20 then
							obj:setVolumePitch(gravelext, fadeSoundDirtEnter, rollPitch)
							obj:setVolumePitch(gravelext2,fadeSoundDirtEnter/4, rollPitch)
							obj:setVolumePitch(gravelInt, 0, 1)
							fadeSoundDirtEnter = fadeSoundDirtEnter + 0.05
						else fadeSoundDirt = rollVol * 20
						end
					else
						obj:setVolumePitch(gravelext, rollVol * 20, rollPitch)
						obj:setVolumePitch(gravelext2, rollVol * 5, rollPitch)
						obj:setVolumePitch(gravelInt, 0, 1)
						fadeSoundDirtEnter = rollVol * 20
						fadeSoundDirt = rollVol * 20
					end
					
				end		
				
			end
			

			if settingsUser.DirtSandParticles == "true" and settingsUser.DirtSandParticles ~= nil then -- If user enabled particles
					if skidVol > 0.1 and skidPitch > 0.8 then -- If skid vol and skid pitch mean that the player is drifting
						if wd.contactMaterialID1 == 18 or wd.contactMaterialID1 == 20 then -- If he is driving on dirt or grass
							obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 18, 0.1, skidPitch+0.2) -- Spawn particles
						end
						obj:addParticleByNodesRelative(1+math.random(10), wd.node2, 1-math.random(1) , 3, 0.1, skidPitch+0.2)
					end		
					
			end	
				
				
		else -- Else if not driving on dirt then disable sounds

			if delay < 0.2 then delay = delay + dt else -- 0.2s delay to prevent "on off on off on off" sound while driving on bumpy road
				obj:setVolumePitch(gravelInt, 0, 1)
				obj:setVolumePitch(gravelSkid, 0, 1)
				obj:setVolumePitch(gravelext, 0, 1)
				obj:setVolumePitch(gravelext2, 0, 1)
				
				if delaySkid > 0 then
					delaySkid = delaySkid - (dt/2) -- 0.2s delay to prevent "on off on off on off" sound skidding on bumpy road
					obj:setVolumePitch(gravelSkid, delaySkid * 3, skidPitch) -- Gravel skid sound
				else
					obj:setVolumePitch(gravelSkid, 0, 1) -- Gravel skid sound
				end
				
				

			end
	
		end
--==========================================================SKID AND DRIVING SOUND===========================================================	

	





--==========================================================FLAT TIRE SOUND SOUND===========================================================
		if settingsUser.TireDeflatedSound == "true" and settingsUser.TireDeflatedSound ~= nil then -- If user enabled tire Sound
			if wd.contactMaterialID1 == 10 and wd.contactMaterialID2 == 4 and wd.contactDepth == 0  then -- If on road
				if deflateTable[wi] == true then -- If any tire is deflated
					generateTirePulse(dt, wd.node1) -- Play sound
				else -- Or disable it
					obj:setVolume(flatTire1, 0)
					obj:setVolume(flatTire2, 0)
				end
			else
					obj:setVolume(flatTire1, 0)
					obj:setVolume(flatTire2, 0)
			end
		end
--========================================================== FLAT TIRE SOUND SOUND===========================================================
		

		
		
		
		
		
--====================================================================TIRE SMOKE======================================================================		
		if settingsUser.TireSmoke == "true" and settingsUser.TireSmoke ~= nil then -- If user enabled tire smoke
		
			if wd.contactMaterialID1 == 10 and wd.contactMaterialID2 == 4 and wd.contactDepth == 0  then --If drive on road
				if skidVol > 0.1 and skidPitch > 0.8 then -- If skid vol and skid pitch mean that the player is drifting
				
					if settingsUser.TireDeflateOnDrift == "true" and settingsUser.TireDeflateOnDrift ~= nil then
						if iTable[wi] > 15 and iTable[wi] < 25 then if math.random(2000) == 250 then beamstate.deflateTire(wi, 1) end end
						if iTable[wi] > 25 then if math.random(500) == 250 then beamstate.deflateTire(wi, 1) end end
					end
					iTableBoolean = false
					if iTable[wi] < 35 then iTable[wi] = iTable[wi] + dt end -- Increase delay
					
					if iTable[wi] > 5 and iTable[wi] < 15 then -- If player is drifting more than 3s then
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 35, 1, 1) -- Spawn particles
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 22, 1, 1) end
			  
					if iTable[wi] > 15 and iTable[wi] < 25 then -- If player is drifting more than 15s then
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 6, 1, 1)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 35, 1, 1)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 22, 1, 1) end
			  
					if iTable[wi] > 25 then -- If player is drifting more than 25s then
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 35, 1, 1)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, 1-math.random(1) , 37, 1, 1) end
						-- Here i wanted to have a chance to explode the tire but i don't know how to explode only the tire that is drifting
						-- Because the tire explode function use 0,1,2 or 3 to define tire and wd.node1 use the tire node number (like 103 or 250)
				elseif skidVol < 0.6 and skidPitch < 1 and iTable[wi] > 1 then
				
				iTable[wi] = iTable[wi] - dt -- Reduce the delay slowly when the player stop drifting
				
				if iTable[wi] > 15 then -- If user drift over more than 15s
					if iTableBoolean == false then iTableSave = iTable[wi] iTableBoolean = true end -- Save iTableSave
					if iTableSave < iTable[wi] + 4 then -- Smoke come frome wheel for 3s
						if math.random(10) == 5 then -- Generate smoke
							obj:addParticleByNodesRelative(wd.node1, wd.node2, 4, 22, 0.4, 2)
							obj:addParticleByNodesRelative(wd.node1, wd.node2, 4, 6, 0.2, 2)
						end
					end
				end
				
				end
			end
			
		end
--====================================================================TIRE SMOKE======================================================================				
		
		
		

		
		

--============================================================================WATER PARTICLES AND SOUND============================================================================	
		if underWater == 1 then	-- If the vehicle is under water
		
			local wheelspeed = math.abs(w.angularVelocity * wd.radius) -- Get wheel speed
			iTable[wi] = 1
			
			if wd.isBroken == false and settingsUser.WaterSound == "true" and settingsUser.WaterSound ~= nil then -- If user enabled water sound and wheel is not broken
				if drivingSounds.cameraMode == "dash" then
					obj:setVolumePitch(waterSound, wheelspeed/5, wheelspeed/4) -- Set the water sound quieter if first person
					fadeSoundWater = wheelspeed/5
				else
					obj:setVolumePitch(waterSound, wheelspeed/10, wheelspeed/2) 
					fadeSoundWater = wheelspeed/10
				end		
			end
			
			if wd.isBroken == false and settingsUser.WaterParticles == "true" and settingsUser.WaterParticles ~= nil then -- If user enabled water particles and wheel is not broken
				local particlesAmount = wheelspeed/3
				if particlesAmount > 4 then particlesAmount = 4 end
				obj:addParticleByNodesRelative(wd.node1, wd.node2, -math.abs(wheelspeed/5), 50, 0.3, particlesAmount) -- Particles while driving in water
			end
			
			if stillUnderWater == 0 then				
				delayUnderWater = 0
				if wd.isBroken == false and velocity > 10 then -- If wheel is not broken and vehicle go fast
					if settingsUser.WaterParticles == "true" and settingsUser.WaterParticles ~= nil then -- If user enabled water particles
						local particlesSpeed = velocity / 6
						if particlesSpeed > 3 then particlesSpeed = 3 end
						obj:addParticleByNodesRelative(wd.node1, wd.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, particlesSpeed, 50, 1, 10)
						obj:addParticleByNodesRelative(wd.node1, wd.node2, particlesSpeed, 50, 1, 10)	-- (Much) Particles when fall in water
					end
					if settingsUser.WaterSound == "true" and settingsUser.WaterSound ~= nil then -- If user enabled water sound
							sounds.playSoundOnceAtNode("waterSplash", v.data.refNodes[0].ref, velocity/20)	
					end
				end
				stillUnderWater = 1
			end		
		else
			if delayUnderWater > 2 then -- Small delay to prevent sound playing more than 1 time
				stillUnderWater = 0
				if fadeSoundWater > 0 then 
					obj:setVolumePitch(waterSound, fadeSoundWater, 1)
					fadeSoundWater = fadeSoundWater - dt
				end
			else delayUnderWater = delayUnderWater + dt end	
		end	


		
		if settingsUser.DirtSandParticles == "true" and settingsUser.DirtSandParticles ~= nil then -- If user enabled sand particles
			if wd.contactMaterialID1 == 16 then -- If driving on sand
				if velocity > 5 then
					obj:addParticleByNodesRelative(1+math.random(10), wd.node2, 1-math.random(1) , 4, 0.3, wheelspeed)
				end
			end
		end
--============================================================================WATER PARTICLES AND SOUND============================================================================			
		
	end		
end


local function tireDeflate(tire)
	deflateTable[tire] = true
end

M.tireDeflate		 = tireDeflate
M.onVehicleSwitched  = onVehicleSwitched
M.jsonInit	   		 = jsonInit
M.onUpdate	    	 = onUpdate
M.onReset 	   		 = onInit
M.focusLost    		 = focusLost
M.focusGained 		 = focusGained
M.updateGFX 		 = onUpdate

return M